#line 1 "C:/C Arm Projects/SineWave - DMA Driven v2/DAC.c"
#line 15 "C:/C Arm Projects/SineWave - DMA Driven v2/DAC.c"
unsigned int *pointer;
unsigned short int x;


const Sine12bit[64] = {
 2048, 2228, 2407, 2583, 2753, 2917, 3072, 3217,
 3351, 3473, 3580, 3673, 3751, 3812, 3855, 3882,
 3891, 3882, 3855, 3812, 3751, 3673, 3580, 3473,
 3351, 3217, 3072, 2917, 2753, 2583, 2407, 2228,
 2048, 1867, 1688, 1513, 1342, 1179, 1024, 878,
 744, 623, 515, 422, 345, 284, 240, 213,
 205, 213, 240, 284, 345, 422, 515, 623,
 744, 878, 1024, 1179, 1342, 1513, 1688, 1867};




void Timer6_Configure(void) {

 CEN_TIM6_CR1_bit = 0;





 ARPE_TIM6_CR1_bit = 1;
 OPM_TIM6_CR1_bit = 0;
 URS_TIM6_CR1_bit = 0;
 UDIS_TIM6_CR1_bit = 0;




 MMS2_TIM6_CR2_bit = 0;
 MMS1_TIM6_CR2_bit = 1;
 MMS0_TIM6_CR2_bit = 0;






 TIM6_DIER.UDE = 0;
 TIM6_DIER.UIE = 0;




 TIM6_ARR = 1157;
 TIM6_PSC = 0;
}





void DAC_Ch1_Config(void) {
 EN2_bit = 0;
 EN1_bit = 0;

 DMAUDRIE2_bit = 0;
 DMAEN2_bit = 1;
 MAMP23_bit = 0;
 MAMP22_bit = 0;
 MAMP21_bit = 0;
 MAMP20_bit = 0;
 WAVE21_bit = 0;
 WAVE20_bit = 0;
 TSEL22_bit = 0;
 TSEL21_bit = 0;
 TSEL20_bit = 0;
 TEN2_bit = 1;
 BOFF2_bit = 0;

 DMAUDRIE1_bit = 0;
 DMAEN1_bit = 1;
 MAMP13_bit = 0;
 MAMP12_bit = 0;
 MAMP11_bit = 0;
 MAMP10_bit = 0;
 WAVE11_bit = 0;
 WAVE10_bit = 0;
 TSEL12_bit = 0;
 TSEL11_bit = 0;
 TSEL10_bit = 0;
 TEN1_bit = 1;
 BOFF1_bit = 0;
}




void DMA1_Stream5_Ch7_Config(void) {


 EN_DMA1_S5CR_bit = 0;
 while (EN_DMA1_S5CR_bit==1) {
 }

 CTCIF5_DMA1_HIFCR_bit = 1;
 CHTIF5_DMA1_HIFCR_bit = 1;
 CTEIF5_DMA1_HIFCR_bit = 1;
 CDMEIF5_DMA1_HIFCR_bit = 1;
 CFEIF5_DMA1_HIFCR_bit = 1;




 DMA1_S5PAR = &DAC_DHR12R1;



 DMA1_S5M0AR = &Sine12bit;


 DMA1_S5NDTR = 64;



 CHSEL2_DMA1_S5CR_bit=1;
 CHSEL1_DMA1_S5CR_bit=1;
 CHSEL0_DMA1_S5CR_bit=1;


 MBURST1_DMA1_S5CR_bit=0;
 MBURST0_DMA1_S5CR_bit=0;


 PBURST1_DMA1_S5CR_bit=0;
 PBURST0_DMA1_S5CR_bit=0;


 ACK_DMA1_S5CR_bit = 0;


 CT_DMA1_S5CR_bit = 0;


 DBM_DMA1_S5CR_bit = 0;


 PL1_DMA1_S5CR_bit=1;
 PL0_DMA1_S5CR_bit=0;


 PINCOS_DMA1_S5CR_bit = 0;


 MSIZE1_DMA1_S5CR_bit=0;
 MSIZE0_DMA1_S5CR_bit=1;


 PSIZE1_DMA1_S5CR_bit=1;
 PSIZE0_DMA1_S5CR_bit=0;


 MINC_DMA1_S5CR_bit = 1;


 PINC_DMA1_S5CR_bit = 0;


 CIRC_DMA1_S5CR_bit = 1;


 DIR1_DMA1_S5CR_bit=0;
 DIR0_DMA1_S5CR_bit=1;

 PFCTRL_DMA1_S5CR_bit = 0;
 TCIE_DMA1_S5CR_bit = 0;
 HTIE_DMA1_S5CR_bit = 0;
 TEIE_DMA1_S5CR_bit = 0;
 DMEIE_DMA1_S5CR_bit = 0;


 DMDIS_DMA1_S5FCR_bit = 0;


 FTH1_DMA1_S5FCR_bit = 0;
 FTH0_DMA1_S5FCR_bit = 1;
}

void main() {

 RCC_AHB1ENR.DMA1EN = 1;
 RCC_AHB1ENR.GPIOAEN = 1;
 RCC_AHB1ENR.GPIODEN = 1;
 RCC_APB1ENR.DACEN = 1;
 RCC_APB1ENR.TIM6EN = 1;
 RCC_APB1ENR.PWREN = 1;
 SYSCFGEN_bit = 1;


 GPIO_Digital_Output(&GPIOD_BASE, _GPIO_PINMASK_0 | _GPIO_PINMASK_12);
 GPIO_Digital_Output(&GPIOD_BASE, _GPIO_PINMASK_0 | _GPIO_PINMASK_13);
 GPIO_Digital_Output(&GPIOD_BASE, _GPIO_PINMASK_0 | _GPIO_PINMASK_14);
 GPIO_Digital_Output(&GPIOD_BASE, _GPIO_PINMASK_0 | _GPIO_PINMASK_15);

 Timer6_Configure();
 DAC_Ch1_Config(void);
 DMA1_Stream5_Ch7_Config(void);
 EN_DMA1_S5CR_bit = 1;
 EN1_bit = 1;
 EN2_bit = 1;
 TIM6_CR1.CEN = 1;

 GPIOD_ODR.F15 = 1;
 GPIOD_ODR.F13 = 1;
 GPIOD_ODR.F14 = 1;
 GPIOD_ODR.F12=1;
 Delay_ms(1000);


 while(1){
 GPIOD_ODR.F13=!GPIOD_ODR.F13;
 if(GPIOD_ODR.F13==0) {
 TIM6_ARR = 1157;
 }
 else {
 TIM6_ARR = 631;
 }
 Delay_ms(500);
 }
}
