#line 1 "C:/C Arm Projects/SineWave - DMA Driven v2/stm32f4xx_rcc.c"
#line 127 "C:/C Arm Projects/SineWave - DMA Driven v2/stm32f4xx_rcc.c"
static __I uint8_t APBAHBPrescTable[16] = {0, 0, 0, 0, 1, 2, 3, 4, 1, 2, 3, 4, 6, 7, 8, 9};
#line 196 "C:/C Arm Projects/SineWave - DMA Driven v2/stm32f4xx_rcc.c"
void RCC_DeInit(void)
{

 RCC->CR |= (uint32_t)0x00000001;


 RCC->CFGR = 0x00000000;


 RCC->CR &= (uint32_t)0xFEF6FFFF;


 RCC->PLLCFGR = 0x24003010;


 RCC->CR &= (uint32_t)0xFFFBFFFF;


 RCC->CIR = 0x00000000;
}
#line 237 "C:/C Arm Projects/SineWave - DMA Driven v2/stm32f4xx_rcc.c"
void RCC_HSEConfig(uint8_t RCC_HSE)
{

 assert_param(IS_RCC_HSE(RCC_HSE));


 *(__IO uint8_t *)  ((uint32_t)0x40023802)  = RCC_HSE_OFF;


 *(__IO uint8_t *)  ((uint32_t)0x40023802)  = RCC_HSE;
}
#line 261 "C:/C Arm Projects/SineWave - DMA Driven v2/stm32f4xx_rcc.c"
ErrorStatus RCC_WaitForHSEStartUp(void)
{
 __IO uint32_t startupcounter = 0;
 ErrorStatus status = ERROR;
 FlagStatus hsestatus = RESET;

 do
 {
 hsestatus = RCC_GetFlagStatus(RCC_FLAG_HSERDY);
 startupcounter++;
 } while((startupcounter != HSE_STARTUP_TIMEOUT) && (hsestatus == RESET));

 if (RCC_GetFlagStatus(RCC_FLAG_HSERDY) != RESET)
 {
 status = SUCCESS;
 }
 else
 {
 status = ERROR;
 }
 return (status);
}
#line 292 "C:/C Arm Projects/SineWave - DMA Driven v2/stm32f4xx_rcc.c"
void RCC_AdjustHSICalibrationValue(uint8_t HSICalibrationValue)
{
 uint32_t tmpreg = 0;

 assert_param(IS_RCC_CALIBRATION_VALUE(HSICalibrationValue));

 tmpreg = RCC->CR;


 tmpreg &= ~RCC_CR_HSITRIM;


 tmpreg |= (uint32_t)HSICalibrationValue << 3;


 RCC->CR = tmpreg;
}
#line 328 "C:/C Arm Projects/SineWave - DMA Driven v2/stm32f4xx_rcc.c"
void RCC_HSICmd(FunctionalState NewState)
{

 assert_param(IS_FUNCTIONAL_STATE(NewState));

 *(__IO uint32_t *)  (PERIPH_BB_BASE + ( ( (RCC_BASE - PERIPH_BASE)  + 0x00)  * 32) + ( 0x00  * 4))  = (uint32_t)NewState;
}
#line 353 "C:/C Arm Projects/SineWave - DMA Driven v2/stm32f4xx_rcc.c"
void RCC_LSEConfig(uint8_t RCC_LSE)
{

 assert_param(IS_RCC_LSE(RCC_LSE));



 *(__IO uint8_t *)  (PERIPH_BASE + ( (RCC_BASE - PERIPH_BASE)  + 0x70) )  = RCC_LSE_OFF;


 *(__IO uint8_t *)  (PERIPH_BASE + ( (RCC_BASE - PERIPH_BASE)  + 0x70) )  = RCC_LSE_OFF;


 switch (RCC_LSE)
 {
 case RCC_LSE_ON:

 *(__IO uint8_t *)  (PERIPH_BASE + ( (RCC_BASE - PERIPH_BASE)  + 0x70) )  = RCC_LSE_ON;
 break;
 case RCC_LSE_Bypass:

 *(__IO uint8_t *)  (PERIPH_BASE + ( (RCC_BASE - PERIPH_BASE)  + 0x70) )  = RCC_LSE_Bypass | RCC_LSE_ON;
 break;
 default:
 break;
 }
}
#line 393 "C:/C Arm Projects/SineWave - DMA Driven v2/stm32f4xx_rcc.c"
void RCC_LSICmd(FunctionalState NewState)
{

 assert_param(IS_FUNCTIONAL_STATE(NewState));

 *(__IO uint32_t *)  (PERIPH_BB_BASE + ( ( (RCC_BASE - PERIPH_BASE)  + 0x74)  * 32) + ( 0x00  * 4))  = (uint32_t)NewState;
}
#line 436 "C:/C Arm Projects/SineWave - DMA Driven v2/stm32f4xx_rcc.c"
void RCC_PLLConfig(uint32_t RCC_PLLSource, uint32_t PLLM, uint32_t PLLN, uint32_t PLLP, uint32_t PLLQ)
{

 assert_param(IS_RCC_PLL_SOURCE(RCC_PLLSource));
 assert_param(IS_RCC_PLLM_VALUE(PLLM));
 assert_param(IS_RCC_PLLN_VALUE(PLLN));
 assert_param(IS_RCC_PLLP_VALUE(PLLP));
 assert_param(IS_RCC_PLLQ_VALUE(PLLQ));

 RCC->PLLCFGR = PLLM | (PLLN << 6) | (((PLLP >> 1) -1) << 16) | (RCC_PLLSource) |
 (PLLQ << 24);
}
#line 459 "C:/C Arm Projects/SineWave - DMA Driven v2/stm32f4xx_rcc.c"
void RCC_PLLCmd(FunctionalState NewState)
{

 assert_param(IS_FUNCTIONAL_STATE(NewState));
 *(__IO uint32_t *)  (PERIPH_BB_BASE + ( ( (RCC_BASE - PERIPH_BASE)  + 0x00)  * 32) + ( 0x18  * 4))  = (uint32_t)NewState;
}
#line 485 "C:/C Arm Projects/SineWave - DMA Driven v2/stm32f4xx_rcc.c"
void RCC_PLLI2SConfig(uint32_t PLLI2SN, uint32_t PLLI2SR)
{

 assert_param(IS_RCC_PLLI2SN_VALUE(PLLI2SN));
 assert_param(IS_RCC_PLLI2SR_VALUE(PLLI2SR));

 RCC->PLLI2SCFGR = (PLLI2SN << 6) | (PLLI2SR << 28);
}
#line 500 "C:/C Arm Projects/SineWave - DMA Driven v2/stm32f4xx_rcc.c"
void RCC_PLLI2SCmd(FunctionalState NewState)
{

 assert_param(IS_FUNCTIONAL_STATE(NewState));
 *(__IO uint32_t *)  (PERIPH_BB_BASE + ( ( (RCC_BASE - PERIPH_BASE)  + 0x00)  * 32) + ( 0x1A  * 4))  = (uint32_t)NewState;
}
#line 518 "C:/C Arm Projects/SineWave - DMA Driven v2/stm32f4xx_rcc.c"
void RCC_ClockSecuritySystemCmd(FunctionalState NewState)
{

 assert_param(IS_FUNCTIONAL_STATE(NewState));
 *(__IO uint32_t *)  (PERIPH_BB_BASE + ( ( (RCC_BASE - PERIPH_BASE)  + 0x00)  * 32) + ( 0x13  * 4))  = (uint32_t)NewState;
}
#line 543 "C:/C Arm Projects/SineWave - DMA Driven v2/stm32f4xx_rcc.c"
void RCC_MCO1Config(uint32_t RCC_MCO1Source, uint32_t RCC_MCO1Div)
{
 uint32_t tmpreg = 0;


 assert_param(IS_RCC_MCO1SOURCE(RCC_MCO1Source));
 assert_param(IS_RCC_MCO1DIV(RCC_MCO1Div));

 tmpreg = RCC->CFGR;


 tmpreg &=  ((uint32_t)0xF89FFFFF) ;


 tmpreg |= RCC_MCO1Source | RCC_MCO1Div;


 RCC->CFGR = tmpreg;
}
#line 581 "C:/C Arm Projects/SineWave - DMA Driven v2/stm32f4xx_rcc.c"
void RCC_MCO2Config(uint32_t RCC_MCO2Source, uint32_t RCC_MCO2Div)
{
 uint32_t tmpreg = 0;


 assert_param(IS_RCC_MCO2SOURCE(RCC_MCO2Source));
 assert_param(IS_RCC_MCO2DIV(RCC_MCO2Div));

 tmpreg = RCC->CFGR;


 tmpreg &=  ((uint32_t)0x07FFFFFF) ;


 tmpreg |= RCC_MCO2Source | RCC_MCO2Div;


 RCC->CFGR = tmpreg;
}
#line 687 "C:/C Arm Projects/SineWave - DMA Driven v2/stm32f4xx_rcc.c"
void RCC_SYSCLKConfig(uint32_t RCC_SYSCLKSource)
{
 uint32_t tmpreg = 0;


 assert_param(IS_RCC_SYSCLK_SOURCE(RCC_SYSCLKSource));

 tmpreg = RCC->CFGR;


 tmpreg &= ~RCC_CFGR_SW;


 tmpreg |= RCC_SYSCLKSource;


 RCC->CFGR = tmpreg;
}
#line 715 "C:/C Arm Projects/SineWave - DMA Driven v2/stm32f4xx_rcc.c"
uint8_t RCC_GetSYSCLKSource(void)
{
 return ((uint8_t)(RCC->CFGR & RCC_CFGR_SWS));
}
#line 740 "C:/C Arm Projects/SineWave - DMA Driven v2/stm32f4xx_rcc.c"
void RCC_HCLKConfig(uint32_t RCC_SYSCLK)
{
 uint32_t tmpreg = 0;


 assert_param(IS_RCC_HCLK(RCC_SYSCLK));

 tmpreg = RCC->CFGR;


 tmpreg &= ~RCC_CFGR_HPRE;


 tmpreg |= RCC_SYSCLK;


 RCC->CFGR = tmpreg;
}
#line 772 "C:/C Arm Projects/SineWave - DMA Driven v2/stm32f4xx_rcc.c"
void RCC_PCLK1Config(uint32_t RCC_HCLK)
{
 uint32_t tmpreg = 0;


 assert_param(IS_RCC_PCLK(RCC_HCLK));

 tmpreg = RCC->CFGR;


 tmpreg &= ~RCC_CFGR_PPRE1;


 tmpreg |= RCC_HCLK;


 RCC->CFGR = tmpreg;
}
#line 803 "C:/C Arm Projects/SineWave - DMA Driven v2/stm32f4xx_rcc.c"
void RCC_PCLK2Config(uint32_t RCC_HCLK)
{
 uint32_t tmpreg = 0;


 assert_param(IS_RCC_PCLK(RCC_HCLK));

 tmpreg = RCC->CFGR;


 tmpreg &= ~RCC_CFGR_PPRE2;


 tmpreg |= RCC_HCLK << 3;


 RCC->CFGR = tmpreg;
}
#line 855 "C:/C Arm Projects/SineWave - DMA Driven v2/stm32f4xx_rcc.c"
void RCC_GetClocksFreq(RCC_ClocksTypeDef* RCC_Clocks)
{
 uint32_t tmp = 0, presc = 0, pllvco = 0, pllp = 2, pllsource = 0, pllm = 2;


 tmp = RCC->CFGR & RCC_CFGR_SWS;

 switch (tmp)
 {
 case 0x00:
 RCC_Clocks->SYSCLK_Frequency = HSI_VALUE;
 break;
 case 0x04:
 RCC_Clocks->SYSCLK_Frequency = HSE_VALUE;
 break;
 case 0x08:
#line 875 "C:/C Arm Projects/SineWave - DMA Driven v2/stm32f4xx_rcc.c"
 pllsource = (RCC->PLLCFGR & RCC_PLLCFGR_PLLSRC) >> 22;
 pllm = RCC->PLLCFGR & RCC_PLLCFGR_PLLM;

 if (pllsource != 0)
 {

 pllvco = (HSE_VALUE / pllm) * ((RCC->PLLCFGR & RCC_PLLCFGR_PLLN) >> 6);
 }
 else
 {

 pllvco = (HSI_VALUE / pllm) * ((RCC->PLLCFGR & RCC_PLLCFGR_PLLN) >> 6);
 }

 pllp = (((RCC->PLLCFGR & RCC_PLLCFGR_PLLP) >>16) + 1 ) *2;
 RCC_Clocks->SYSCLK_Frequency = pllvco/pllp;
 break;
 default:
 RCC_Clocks->SYSCLK_Frequency = HSI_VALUE;
 break;
 }



 tmp = RCC->CFGR & RCC_CFGR_HPRE;
 tmp = tmp >> 4;
 presc = APBAHBPrescTable[tmp];

 RCC_Clocks->HCLK_Frequency = RCC_Clocks->SYSCLK_Frequency >> presc;


 tmp = RCC->CFGR & RCC_CFGR_PPRE1;
 tmp = tmp >> 10;
 presc = APBAHBPrescTable[tmp];

 RCC_Clocks->PCLK1_Frequency = RCC_Clocks->HCLK_Frequency >> presc;


 tmp = RCC->CFGR & RCC_CFGR_PPRE2;
 tmp = tmp >> 13;
 presc = APBAHBPrescTable[tmp];

 RCC_Clocks->PCLK2_Frequency = RCC_Clocks->HCLK_Frequency >> presc;
}
#line 980 "C:/C Arm Projects/SineWave - DMA Driven v2/stm32f4xx_rcc.c"
void RCC_RTCCLKConfig(uint32_t RCC_RTCCLKSource)
{
 uint32_t tmpreg = 0;


 assert_param(IS_RCC_RTCCLK_SOURCE(RCC_RTCCLKSource));

 if ((RCC_RTCCLKSource & 0x00000300) == 0x00000300)
 {
 tmpreg = RCC->CFGR;


 tmpreg &= ~RCC_CFGR_RTCPRE;


 tmpreg |= (RCC_RTCCLKSource & 0xFFFFCFF);


 RCC->CFGR = tmpreg;
 }


 RCC->BDCR |= (RCC_RTCCLKSource & 0x00000FFF);
}
#line 1012 "C:/C Arm Projects/SineWave - DMA Driven v2/stm32f4xx_rcc.c"
void RCC_RTCCLKCmd(FunctionalState NewState)
{

 assert_param(IS_FUNCTIONAL_STATE(NewState));

 *(__IO uint32_t *)  (PERIPH_BB_BASE + ( ( (RCC_BASE - PERIPH_BASE)  + 0x70)  * 32) + ( 0x0F  * 4))  = (uint32_t)NewState;
}
#line 1029 "C:/C Arm Projects/SineWave - DMA Driven v2/stm32f4xx_rcc.c"
void RCC_BackupResetCmd(FunctionalState NewState)
{

 assert_param(IS_FUNCTIONAL_STATE(NewState));
 *(__IO uint32_t *)  (PERIPH_BB_BASE + ( ( (RCC_BASE - PERIPH_BASE)  + 0x70)  * 32) + ( 0x10  * 4))  = (uint32_t)NewState;
}
#line 1046 "C:/C Arm Projects/SineWave - DMA Driven v2/stm32f4xx_rcc.c"
void RCC_I2SCLKConfig(uint32_t RCC_I2SCLKSource)
{

 assert_param(IS_RCC_I2SCLK_SOURCE(RCC_I2SCLKSource));

 *(__IO uint32_t *)  (PERIPH_BB_BASE + ( ( (RCC_BASE - PERIPH_BASE)  + 0x08)  * 32) + ( 0x17  * 4))  = RCC_I2SCLKSource;
}
#line 1085 "C:/C Arm Projects/SineWave - DMA Driven v2/stm32f4xx_rcc.c"
void RCC_AHB1PeriphClockCmd(uint32_t RCC_AHB1Periph, FunctionalState NewState)
{

 assert_param(IS_RCC_AHB1_CLOCK_PERIPH(RCC_AHB1Periph));

 assert_param(IS_FUNCTIONAL_STATE(NewState));
 if (NewState != DISABLE)
 {
 RCC->AHB1ENR |= RCC_AHB1Periph;
 }
 else
 {
 RCC->AHB1ENR &= ~RCC_AHB1Periph;
 }
}
#line 1117 "C:/C Arm Projects/SineWave - DMA Driven v2/stm32f4xx_rcc.c"
void RCC_AHB2PeriphClockCmd(uint32_t RCC_AHB2Periph, FunctionalState NewState)
{

 assert_param(IS_RCC_AHB2_PERIPH(RCC_AHB2Periph));
 assert_param(IS_FUNCTIONAL_STATE(NewState));

 if (NewState != DISABLE)
 {
 RCC->AHB2ENR |= RCC_AHB2Periph;
 }
 else
 {
 RCC->AHB2ENR &= ~RCC_AHB2Periph;
 }
}
#line 1144 "C:/C Arm Projects/SineWave - DMA Driven v2/stm32f4xx_rcc.c"
void RCC_AHB3PeriphClockCmd(uint32_t RCC_AHB3Periph, FunctionalState NewState)
{

 assert_param(IS_RCC_AHB3_PERIPH(RCC_AHB3Periph));
 assert_param(IS_FUNCTIONAL_STATE(NewState));

 if (NewState != DISABLE)
 {
 RCC->AHB3ENR |= RCC_AHB3Periph;
 }
 else
 {
 RCC->AHB3ENR &= ~RCC_AHB3Periph;
 }
}
#line 1194 "C:/C Arm Projects/SineWave - DMA Driven v2/stm32f4xx_rcc.c"
void RCC_APB1PeriphClockCmd(uint32_t RCC_APB1Periph, FunctionalState NewState)
{

 assert_param(IS_RCC_APB1_PERIPH(RCC_APB1Periph));
 assert_param(IS_FUNCTIONAL_STATE(NewState));

 if (NewState != DISABLE)
 {
 RCC->APB1ENR |= RCC_APB1Periph;
 }
 else
 {
 RCC->APB1ENR &= ~RCC_APB1Periph;
 }
}
#line 1234 "C:/C Arm Projects/SineWave - DMA Driven v2/stm32f4xx_rcc.c"
void RCC_APB2PeriphClockCmd(uint32_t RCC_APB2Periph, FunctionalState NewState)
{

 assert_param(IS_RCC_APB2_PERIPH(RCC_APB2Periph));
 assert_param(IS_FUNCTIONAL_STATE(NewState));

 if (NewState != DISABLE)
 {
 RCC->APB2ENR |= RCC_APB2Periph;
 }
 else
 {
 RCC->APB2ENR &= ~RCC_APB2Periph;
 }
}
#line 1273 "C:/C Arm Projects/SineWave - DMA Driven v2/stm32f4xx_rcc.c"
void RCC_AHB1PeriphResetCmd(uint32_t RCC_AHB1Periph, FunctionalState NewState)
{

 assert_param(IS_RCC_AHB1_RESET_PERIPH(RCC_AHB1Periph));
 assert_param(IS_FUNCTIONAL_STATE(NewState));

 if (NewState != DISABLE)
 {
 RCC->AHB1RSTR |= RCC_AHB1Periph;
 }
 else
 {
 RCC->AHB1RSTR &= ~RCC_AHB1Periph;
 }
}
#line 1302 "C:/C Arm Projects/SineWave - DMA Driven v2/stm32f4xx_rcc.c"
void RCC_AHB2PeriphResetCmd(uint32_t RCC_AHB2Periph, FunctionalState NewState)
{

 assert_param(IS_RCC_AHB2_PERIPH(RCC_AHB2Periph));
 assert_param(IS_FUNCTIONAL_STATE(NewState));

 if (NewState != DISABLE)
 {
 RCC->AHB2RSTR |= RCC_AHB2Periph;
 }
 else
 {
 RCC->AHB2RSTR &= ~RCC_AHB2Periph;
 }
}
#line 1326 "C:/C Arm Projects/SineWave - DMA Driven v2/stm32f4xx_rcc.c"
void RCC_AHB3PeriphResetCmd(uint32_t RCC_AHB3Periph, FunctionalState NewState)
{

 assert_param(IS_RCC_AHB3_PERIPH(RCC_AHB3Periph));
 assert_param(IS_FUNCTIONAL_STATE(NewState));

 if (NewState != DISABLE)
 {
 RCC->AHB3RSTR |= RCC_AHB3Periph;
 }
 else
 {
 RCC->AHB3RSTR &= ~RCC_AHB3Periph;
 }
}
#line 1373 "C:/C Arm Projects/SineWave - DMA Driven v2/stm32f4xx_rcc.c"
void RCC_APB1PeriphResetCmd(uint32_t RCC_APB1Periph, FunctionalState NewState)
{

 assert_param(IS_RCC_APB1_PERIPH(RCC_APB1Periph));
 assert_param(IS_FUNCTIONAL_STATE(NewState));
 if (NewState != DISABLE)
 {
 RCC->APB1RSTR |= RCC_APB1Periph;
 }
 else
 {
 RCC->APB1RSTR &= ~RCC_APB1Periph;
 }
}
#line 1409 "C:/C Arm Projects/SineWave - DMA Driven v2/stm32f4xx_rcc.c"
void RCC_APB2PeriphResetCmd(uint32_t RCC_APB2Periph, FunctionalState NewState)
{

 assert_param(IS_RCC_APB2_RESET_PERIPH(RCC_APB2Periph));
 assert_param(IS_FUNCTIONAL_STATE(NewState));
 if (NewState != DISABLE)
 {
 RCC->APB2RSTR |= RCC_APB2Periph;
 }
 else
 {
 RCC->APB2RSTR &= ~RCC_APB2Periph;
 }
}
#line 1455 "C:/C Arm Projects/SineWave - DMA Driven v2/stm32f4xx_rcc.c"
void RCC_AHB1PeriphClockLPModeCmd(uint32_t RCC_AHB1Periph, FunctionalState NewState)
{

 assert_param(IS_RCC_AHB1_LPMODE_PERIPH(RCC_AHB1Periph));
 assert_param(IS_FUNCTIONAL_STATE(NewState));
 if (NewState != DISABLE)
 {
 RCC->AHB1LPENR |= RCC_AHB1Periph;
 }
 else
 {
 RCC->AHB1LPENR &= ~RCC_AHB1Periph;
 }
}
#line 1487 "C:/C Arm Projects/SineWave - DMA Driven v2/stm32f4xx_rcc.c"
void RCC_AHB2PeriphClockLPModeCmd(uint32_t RCC_AHB2Periph, FunctionalState NewState)
{

 assert_param(IS_RCC_AHB2_PERIPH(RCC_AHB2Periph));
 assert_param(IS_FUNCTIONAL_STATE(NewState));
 if (NewState != DISABLE)
 {
 RCC->AHB2LPENR |= RCC_AHB2Periph;
 }
 else
 {
 RCC->AHB2LPENR &= ~RCC_AHB2Periph;
 }
}
#line 1514 "C:/C Arm Projects/SineWave - DMA Driven v2/stm32f4xx_rcc.c"
void RCC_AHB3PeriphClockLPModeCmd(uint32_t RCC_AHB3Periph, FunctionalState NewState)
{

 assert_param(IS_RCC_AHB3_PERIPH(RCC_AHB3Periph));
 assert_param(IS_FUNCTIONAL_STATE(NewState));
 if (NewState != DISABLE)
 {
 RCC->AHB3LPENR |= RCC_AHB3Periph;
 }
 else
 {
 RCC->AHB3LPENR &= ~RCC_AHB3Periph;
 }
}
#line 1564 "C:/C Arm Projects/SineWave - DMA Driven v2/stm32f4xx_rcc.c"
void RCC_APB1PeriphClockLPModeCmd(uint32_t RCC_APB1Periph, FunctionalState NewState)
{

 assert_param(IS_RCC_APB1_PERIPH(RCC_APB1Periph));
 assert_param(IS_FUNCTIONAL_STATE(NewState));
 if (NewState != DISABLE)
 {
 RCC->APB1LPENR |= RCC_APB1Periph;
 }
 else
 {
 RCC->APB1LPENR &= ~RCC_APB1Periph;
 }
}
#line 1604 "C:/C Arm Projects/SineWave - DMA Driven v2/stm32f4xx_rcc.c"
void RCC_APB2PeriphClockLPModeCmd(uint32_t RCC_APB2Periph, FunctionalState NewState)
{

 assert_param(IS_RCC_APB2_PERIPH(RCC_APB2Periph));
 assert_param(IS_FUNCTIONAL_STATE(NewState));
 if (NewState != DISABLE)
 {
 RCC->APB2LPENR |= RCC_APB2Periph;
 }
 else
 {
 RCC->APB2LPENR &= ~RCC_APB2Periph;
 }
}
#line 1649 "C:/C Arm Projects/SineWave - DMA Driven v2/stm32f4xx_rcc.c"
void RCC_ITConfig(uint8_t RCC_IT, FunctionalState NewState)
{

 assert_param(IS_RCC_IT(RCC_IT));
 assert_param(IS_FUNCTIONAL_STATE(NewState));
 if (NewState != DISABLE)
 {

 *(__IO uint8_t *)  ((uint32_t)(RCC_BASE + 0x0C + 0x01))  |= RCC_IT;
 }
 else
 {

 *(__IO uint8_t *)  ((uint32_t)(RCC_BASE + 0x0C + 0x01))  &= (uint8_t)~RCC_IT;
 }
}
#line 1685 "C:/C Arm Projects/SineWave - DMA Driven v2/stm32f4xx_rcc.c"
FlagStatus RCC_GetFlagStatus(uint8_t RCC_FLAG)
{
 uint32_t tmp = 0;
 uint32_t statusreg = 0;
 FlagStatus bitstatus = RESET;


 assert_param(IS_RCC_FLAG(RCC_FLAG));


 tmp = RCC_FLAG >> 5;
 if (tmp == 1)
 {
 statusreg = RCC->CR;
 }
 else if (tmp == 2)
 {
 statusreg = RCC->BDCR;
 }
 else
 {
 statusreg = RCC->CSR;
 }


 tmp = RCC_FLAG &  ((uint8_t)0x1F) ;
 if ((statusreg & ((uint32_t)1 << tmp)) != (uint32_t)RESET)
 {
 bitstatus = SET;
 }
 else
 {
 bitstatus = RESET;
 }

 return bitstatus;
}
#line 1730 "C:/C Arm Projects/SineWave - DMA Driven v2/stm32f4xx_rcc.c"
void RCC_ClearFlag(void)
{

 RCC->CSR |= RCC_CSR_RMVF;
}
#line 1749 "C:/C Arm Projects/SineWave - DMA Driven v2/stm32f4xx_rcc.c"
ITStatus RCC_GetITStatus(uint8_t RCC_IT)
{
 ITStatus bitstatus = RESET;


 assert_param(IS_RCC_GET_IT(RCC_IT));


 if ((RCC->CIR & RCC_IT) != (uint32_t)RESET)
 {
 bitstatus = SET;
 }
 else
 {
 bitstatus = RESET;
 }

 return bitstatus;
}
#line 1782 "C:/C Arm Projects/SineWave - DMA Driven v2/stm32f4xx_rcc.c"
void RCC_ClearITPendingBit(uint8_t RCC_IT)
{

 assert_param(IS_RCC_CLEAR_IT(RCC_IT));
#line 1789 "C:/C Arm Projects/SineWave - DMA Driven v2/stm32f4xx_rcc.c"
 *(__IO uint8_t *)  ((uint32_t)(RCC_BASE + 0x0C + 0x02))  = RCC_IT;
}
